/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperandsVec;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 148 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 30,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 31,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 32,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 34,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 35,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 43,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 44,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 45,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 46,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 47,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 48,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 49,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 50,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 51,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 52,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 53,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 54,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 55,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 56,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 57,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 58,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 59,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 60,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 61,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 62,                    /* RBRACE  */
  YYSYMBOL_DOT = 63,                       /* DOT  */
  YYSYMBOL_COMMA = 64,                     /* COMMA  */
  YYSYMBOL_SEMI = 65,                      /* SEMI  */
  YYSYMBOL_COLON = 66,                     /* COLON  */
  YYSYMBOL_SLASH = 67,                     /* SLASH  */
  YYSYMBOL_PERCENT = 68,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 69,                    /* EQUALS  */
  YYSYMBOL_PLUS = 70,                      /* PLUS  */
  YYSYMBOL_MINUS = 71,                     /* MINUS  */
  YYSYMBOL_TIMES = 72,                     /* TIMES  */
  YYSYMBOL_AMP = 73,                       /* AMP  */
  YYSYMBOL_CIRC = 74,                      /* CIRC  */
  YYSYMBOL_PIPE = 75,                      /* PIPE  */
  YYSYMBOL_TILDE = 76,                     /* TILDE  */
  YYSYMBOL_BANG = 77,                      /* BANG  */
  YYSYMBOL_QUESTION = 78,                  /* QUESTION  */
  YYSYMBOL_LEQ = 79,                       /* LEQ  */
  YYSYMBOL_GEQ = 80,                       /* GEQ  */
  YYSYMBOL_EQ = 81,                        /* EQ  */
  YYSYMBOL_NEQ = 82,                       /* NEQ  */
  YYSYMBOL_SHL = 83,                       /* SHL  */
  YYSYMBOL_SHRS = 84,                      /* SHRS  */
  YYSYMBOL_SHRZ = 85,                      /* SHRZ  */
  YYSYMBOL_LABEL = 86,                     /* LABEL  */
  YYSYMBOL_IDENT = 87,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 88,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 89,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 90,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 91,                   /* NEWLINE  */
  YYSYMBOL_UNIFORM = 92,                   /* UNIFORM  */
  YYSYMBOL_RTWRITE_OPTION = 93,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 94,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 95,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 96,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 97,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 98,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 99,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 100,            /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 101,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 102,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 103,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 104,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 105,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 106,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 107,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 108,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 109,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 110,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 111,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 112,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 113,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 114,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 115,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 116,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 117,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 118,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 119,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 120,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 121,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 122,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 123,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 124,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 125,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 126,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 127,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 128,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 129,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 130,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 131,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 132,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 133,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 134,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 135,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 136,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 137,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 138,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 139,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 140,                   /* IFCALL  */
  YYSYMBOL_FCALL = 141,                    /* FCALL  */
  YYSYMBOL_FADDR = 142,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 143,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 144,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 145,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 146,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 147,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 148,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 149,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 150,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 151,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 152,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 153,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 154,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 155,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 156,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 157,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 158,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 159,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 160,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 161,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 162,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 163,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 164,                   /* AVS_OP  */
  YYSYMBOL_BREAKPOINT_OP = 165,            /* BREAKPOINT_OP  */
  YYSYMBOL_CALL_OP = 166,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 167,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 168,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 169,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 170,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 171,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 172,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 173, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 174,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 175,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 176,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 177,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 178, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 179, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 180,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 181,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 182,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 183,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 184,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 185,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 186,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 187,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 188,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 189,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 190, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 191, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 192,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 193, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 194, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 195,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 196, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 197,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 198,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 199,                 /* $accept  */
  YYSYMBOL_Listing = 200,                  /* Listing  */
  YYSYMBOL_ListingHeader = 201,            /* ListingHeader  */
  YYSYMBOL_Statements = 202,               /* Statements  */
  YYSYMBOL_Newlines = 203,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 204,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 205,                /* Statement  */
  YYSYMBOL_Scope = 206,                    /* Scope  */
  YYSYMBOL_ScopeStart = 207,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 208,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 209,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 210,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 211,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 212,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 213,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 214,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 215,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 216,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 217,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 218,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 219,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 220,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 221,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 222,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 223,              /* InputOffset  */
  YYSYMBOL_InputSize = 224,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 225,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 226,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 227,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 228,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 229,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 230,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 231,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 232,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 233,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 234,              /* Instruction  */
  YYSYMBOL_Label = 235,                    /* Label  */
  YYSYMBOL_LogicInstruction = 236,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 237,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 238,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 239,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 240,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 241,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 242,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 243,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 244,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 245,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 246,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 247,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 248,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 249,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 250,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 251,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 252,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 253,           /* MovInstruction  */
  YYSYMBOL_BreakpointInstruction = 254,    /* BreakpointInstruction  */
  YYSYMBOL_MovsInstruction = 255,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 256,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 257,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 258,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 259,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 260,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 261, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 262, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 263, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 264,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 265,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 266,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 267,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 268,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 269,      /* Sample3dInstruction  */
  YYSYMBOL_Sample3DInstruction = 270,      /* Sample3DInstruction  */
  YYSYMBOL_CPSEnableOpt = 271,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 272, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 273,        /* Load3dInstruction  */
  YYSYMBOL_Load3DInstruction = 274,        /* Load3DInstruction  */
  YYSYMBOL_Gather43dInstruction = 275,     /* Gather43dInstruction  */
  YYSYMBOL_Gather43DInstruction = 276,     /* Gather43DInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 277,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 278,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 279,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 280,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 281,       /* RTWriteInstruction  */
  YYSYMBOL_RTWInstruction = 282,           /* RTWInstruction  */
  YYSYMBOL_RTWriteModeOpt = 283,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 284,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 285,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 286,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 287,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 288,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 289,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 290,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 291,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 292,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 293,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 294,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 295,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 296,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 297,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 298,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 299,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 300,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 301,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 302,                 /* LscFence  */
  YYSYMBOL_LscSfid = 303,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 304,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 305,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 306, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 307, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperand = 308, /* LscTypedAddrWithOffsetOperand  */
  YYSYMBOL_LscTypedAddrWithOffsetOperandList = 309, /* LscTypedAddrWithOffsetOperandList  */
  YYSYMBOL_LscTypedAddrOperandWithOffsets = 310, /* LscTypedAddrOperandWithOffsets  */
  YYSYMBOL_LscAddrImmOffsetOpt = 311,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 312,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 313,          /* LscAddrModelOpt  */
  YYSYMBOL_LscAddrModelStateful = 314,     /* LscAddrModelStateful  */
  YYSYMBOL_LscVectorOpRegOrImm32 = 315,    /* LscVectorOpRegOrImm32  */
  YYSYMBOL_LscVectorOpImm32 = 316,         /* LscVectorOpImm32  */
  YYSYMBOL_LscVectorOpReg = 317,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 318,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 319,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 320,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 321,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 322,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 323,        /* BranchInstruction  */
  YYSYMBOL_FILE = 324,                     /* FILE  */
  YYSYMBOL_LOC = 325,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 326,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 327,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 328,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 329,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 330,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 331,            /* OwordModifier  */
  YYSYMBOL_Predicate = 332,                /* Predicate  */
  YYSYMBOL_PredSign = 333,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 334,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 335,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 336,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 337,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 338,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 339,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 340,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 341, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 342,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 343,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 344,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 345,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 346,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 347,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 348,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 349,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 350,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 351,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 352,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 353,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 354,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 355,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 356,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 357,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 358,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 359,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 360,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 361,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 362,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 363,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 364,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 365,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 366,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 367,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 368,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 369,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 370,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 371,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 372,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 373,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 374,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 375,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 376,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 377,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 378,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 379,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 380,              /* ExecSizeInt  */
  YYSYMBOL_Var = 381,                      /* Var  */
  YYSYMBOL_VarNonNull = 382,               /* VarNonNull  */
  YYSYMBOL_IntExp = 383,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 384,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 385,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 386,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 387,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 388,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 389,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 390,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 391,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 392,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 393,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 394,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 395,               /* IntExpPrim  */
  YYSYMBOL_DataType = 396,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 397       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3342

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  199
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  199
/* YYNRULES -- Number of rules.  */
#define YYNRULES  449
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1136

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   453


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   660,   660,   665,   667,   667,   669,   669,   670,   670,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   688,   689,   690,   694,   698,   701,   701,   708,   716,
     724,   731,   732,   733,   734,   735,   736,   738,   745,   753,
     761,   768,   772,   772,   775,   783,   788,   800,   807,   815,
     815,   816,   823,   829,   833,   837,   841,   846,   852,   852,
     854,   858,   864,   872,   878,   883,   888,   894,   898,   902,
     908,   913,   919,   923,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   985,   989,   995,  1000,  1006,
    1013,  1019,  1026,  1033,  1040,  1047,  1059,  1066,  1075,  1085,
    1091,  1098,  1104,  1113,  1123,  1130,  1137,  1145,  1154,  1161,
    1168,  1174,  1180,  1186,  1192,  1210,  1217,  1227,  1235,  1242,
    1249,  1258,  1267,  1276,  1284,  1287,  1290,  1293,  1296,  1301,
    1308,  1316,  1317,  1323,  1336,  1344,  1351,  1354,  1369,  1369,
    1371,  1371,  1373,  1376,  1389,  1392,  1405,  1405,  1408,  1416,
    1424,  1427,  1431,  1436,  1439,  1451,  1451,  1455,  1463,  1475,
    1491,  1497,  1510,  1518,  1525,  1533,  1539,  1545,  1551,  1557,
    1564,  1565,  1574,  1575,  1576,  1578,  1579,  1580,  1582,  1585,
    1586,  1587,  1588,  1590,  1617,  1649,  1679,  1707,  1733,  1761,
    1790,  1824,  1868,  1913,  1949,  1988,  1993,  1993,  1996,  1997,
    1998,  2002,  2011,  2017,  2026,  2046,  2065,  2069,  2072,  2077,
    2080,  2085,  2091,  2099,  2112,  2113,  2114,  2119,  2120,  2123,
    2124,  2125,  2126,  2130,  2133,  2136,  2139,  2142,  2145,  2150,
    2150,  2154,  2164,  2172,  2180,  2194,  2198,  2204,  2209,  2212,
    2216,  2219,  2224,  2227,  2230,  2237,  2241,  2245,  2249,  2255,
    2260,  2267,  2274,  2279,  2284,  2290,  2297,  2304,  2310,  2316,
    2324,  2332,  2340,  2350,  2355,  2360,  2365,  2370,  2375,  2380,
    2385,  2390,  2390,  2396,  2401,  2406,  2406,  2408,  2408,  2411,
    2411,  2414,  2415,  2416,  2417,  2419,  2419,  2424,  2425,  2427,
    2428,  2432,  2433,  2436,  2437,  2440,  2441,  2442,  2445,  2446,
    2449,  2450,  2451,  2454,  2455,  2458,  2459,  2461,  2463,  2473,
    2480,  2488,  2496,  2515,  2527,  2534,  2546,  2551,  2558,  2563,
    2571,  2579,  2585,  2590,  2612,  2616,  2622,  2632,  2640,  2647,
    2657,  2663,  2670,  2674,  2679,  2683,  2689,  2690,  2697,  2705,
    2706,  2712,  2722,  2730,  2739,  2757,  2771,  2774,  2785,  2796,
    2801,  2806,  2814,  2823,  2835,  2849,  2851,  2862,  2874,  2880,
    2888,  2897,  2897,  2898,  2898,  2901,  2903,  2904,  2906,  2907,
    2909,  2910,  2912,  2913,  2915,  2916,  2917,  2919,  2920,  2921,
    2922,  2923,  2942,  2945,  2946,  2947,  2948,  2950,  2951,  2952,
    2954,  2955,  2960,  2965,  2967,  2968,  2969,  2970,  2974,  2975,
    2977,  2981,  2985,  2991,  3000,  3001,  3002,  3003,  3005,  3006
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SEND_STRING", "RAW_SENDC_STRING", "RAW_SENDS_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING",
  "SAT", "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT",
  "BFN_OP", "DPAS_OP", "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL",
  "NBARRIER_WAIT", "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE",
  "VTYPE", "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK",
  "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA",
  "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES",
  "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ",
  "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL",
  "BUILTIN", "STRING_LIT", "NEWLINE", "UNIFORM", "RTWRITE_OPTION",
  "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT",
  "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "BREAKPOINT_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "FCvtInstruction",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "BreakpointInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "Sample3DInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Load3DInstruction", "Gather43dInstruction",
  "Gather43DInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperands", "RTWriteInstruction",
  "RTWInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrWithOffsetOperand",
  "LscTypedAddrWithOffsetOperandList", "LscTypedAddrOperandWithOffsets",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscAddrModelStateful", "LscVectorOpRegOrImm32", "LscVectorOpImm32",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "SwitchLabels", "BranchInstruction", "FILE",
  "LOC", "RawSendInstruction", "LifetimeStartInst", "LifetimeEndInst",
  "RawSendsInstruction", "NullaryInstruction", "OwordModifier",
  "Predicate", "PredSign", "PredCtrlOpt", "SatModOpt", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A_AO",
  "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO", "VecSrcOperand_G_A",
  "VecSrcOperand_G_A_AO", "VecSrcOperand_G", "VecSrcOpndSimple",
  "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand", "DstStateOperand",
  "RawOperand", "RawOperandNonNull", "RawOperandOffsetSuffix",
  "RawOperandArray", "DstAddrOperand", "DstGeneralOperand",
  "DstIndirectOperand", "SrcAddrOfOperand", "AddrOfVar", "SrcAddrOperand",
  "SrcGeneralOperand", "SrcImmOperand", "FloatLit", "DoubleFloatLit",
  "SrcIndirectOperand", "DstRegion", "SrcRegionDirect",
  "SrcRegionIndirect", "IndirectVarAccess", "TwoDimOffset", "PredVar",
  "AddrVarAccess", "AddrVarAccessWithWidth", "SIMDMode", "ElemNum",
  "ExecSize", "ExecSizeInt", "Var", "VarNonNull", "IntExp", "IntExpCond",
  "IntExpAND", "IntExpXOR", "IntExpOR", "IntExpCmp", "IntExpRel",
  "IntExpNRA", "IntExpShift", "IntExpAdd", "IntExpMul", "IntExpUnr",
  "IntExpPrim", "DataType", "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1007)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-439)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -13, -1007,    92,    13,    87, -1007, -1007,   -45,   -13, -1007,
     151,  3082,    64,    91,     3,   146,     3,   102,   173,     3,
     191,   205,   231,   978,   978,   237, -1007, -1007,   231,   267,
      15,   264,   268,   302, -1007, -1007, -1007,   277,   298,   343,
     261,   354,     3,   231,   231,   231,   330,   251, -1007,   287,
     323,   324, -1007, -1007,   331,   332,   342,   346,   334, -1007,
    -127,   398,   -13, -1007, -1007,  2751, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,  3146,
   -1007,   248, -1007, -1007, -1007, -1007, -1007,   420,   420, -1007,
     370,   419,   -39,   265, -1007, -1007, -1007, -1007,   261,   366,
     170,   366,   366, -1007, -1007, -1007, -1007, -1007,    22,   321,
      -6, -1007,    10,   978, -1007, -1007, -1007, -1007, -1007, -1007,
     387,   385, -1007,    28, -1007, -1007, -1007,   261,   261, -1007,
     231,   231,   231,   978, -1007,   231,   385,   276,   231,   390,
     356,   281,   261,   265,   978,   261,    10,   978,   261,   261,
   -1007, -1007,   261, -1007, -1007, -1007, -1007, -1007,   231,   231,
   -1007, -1007,   261, -1007, -1007,   269, -1007,   231,  2495, -1007,
   -1007,  2921,   231,   231,   302,   302,   302,   302,   398,   398,
     398,   398,   398,   398,   398,   398,   398,   398,   398,   398,
     398,   398,   231,   389,   371,   373,   458,   374,   411,   379,
     472,   473,   231,   231,    -4,   231,   398,   451,   451,   451,
     388,   231,   231,   421,   -77,   295,   296,   -55,   299,   301,
     -12,   297,   442,   476,   477,   478,   479,   366,   105,   419,
     355,   366,   484, -1007,   443,   438,   441,   265, -1007,   444,
       5,   446,   366, -1007, -1007,   450, -1007,    67,   432,   436,
   -1007,   145,    58, -1007,   167,   172, -1007,   193, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,   425, -1007,
     387,   385, -1007,   366, -1007,   181,   366,   459, -1007, -1007,
   -1007,   347, -1007,    27, -1007, -1007,   456,    10,   978,   978,
     265,   261,   261, -1007,   264,   348,   261,   261,   455,   265,
     265,   466,   265, -1007, -1007, -1007,   469,   139,   474,   261,
     978, -1007,   152,   978,   261,   261,   261,   345,   261, -1007,
   -1007,   -13, -1007,   361,   363,   302,   302,   302,   302,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,    10,   376,   231,   231,   480,   231,   377,
     231,   481,   481,     3, -1007,   231,   978,   453,   231, -1007,
     514,   452,   457, -1007,   231,   384,     3,   386,   383,   383,
     383,   383,   383,   383,   383,   383,   383,   383,   317,   540,
     366,   366,   366,   366, -1007,   501,   484, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007,   396,   397,   265,   -16, -1007, -1007,
     366,   366, -1007,   366,   366,   366,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   366,
     366,   511,   181,   459,   190,   142, -1007, -1007, -1007, -1007,
   -1007,   513,   366, -1007, -1007,   518,   261, -1007,  1048, -1007,
   -1007,   528, -1007, -1007,   529,   366,   978,   978,   139,   265,
     265, -1007,   978,  1169,   261,   527,   317,   261,   422,   265,
     265,   978,   265,   366,   181, -1007,   469,   -10, -1007,   531,
   -1007, -1007,   532,   366, -1007,   265,   265,   978, -1007,   287,
     535,   423,   431,   302,   302,   302,   302,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,   539,   978,   978,   433,   231,   261,   231,   261,
     434,   231,   231, -1007,   978,   435,   439,    10, -1007,   580,
     231,   231,   261,   460, -1007,   231,   454,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   441,   234, -1007,
   -1007,   444,   366,   484,   484,   605,   605,   541, -1007,   566,
   -1007,   261,   366, -1007,   570,   571,   432,    23,   436, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007,   172,   172,   232,   232,
     232, -1007, -1007, -1007, -1007, -1007, -1007,   462,   366,   366,
     366,   572, -1007, -1007, -1007, -1007, -1007, -1007,   366,   366,
     575,   978,   978, -1007, -1007,   265,   117,   978,   978,   978,
   -1007,   265,   265,   978,   576,   265, -1007,   577,   265,   587,
   -1007, -1007,   -10,   -10,   583,   366,   366,    98,   265, -1007,
     978, -1007, -1007,   496,   498,   302,   302,   231,   231,   978,
     978,   261,   978,   261,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   499,   265,   265, -1007,
     265,   265,   261,   978, -1007,   261,   261,   500,   502,   503,
      47,    47,   199, -1007,   551,   978,   978, -1007,   265,   261,
   -1007,   317,   317,   317,   317,   115,   234,   115,   468,   317,
     317,   590,   592,   615,   619,   662, -1007, -1007,   606,   484,
     484,   625, -1007,    80, -1007, -1007,   385,   635, -1007, -1007,
     366,   641,   633,   638,   642,   126,   647, -1007, -1007, -1007,
     978,   265,   265,   265,   265,   978, -1007,   265,   978, -1007,
   -1007, -1007, -1007, -1007,   643,   202, -1007, -1007,   978,   287,
     287,   231,   231,   287,   287,   978, -1007, -1007,   978,   261,
     978,   978,   978,   978,   978, -1007, -1007,   978, -1007,   978,
     978,   978,   231,   265,   265,   265,   265,   978,   265,   265,
     265,   534, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007,   529,   231,   261,   261,  1210,   265,   265,   115,   134,
     234,   115,   468,   523, -1007, -1007,   317,   649, -1007,   317,
     650, -1007,   317,   651,   652,   317,   115,   234,   136,   136,
     136,    63,    32,   694, -1007, -1007, -1007, -1007,   402, -1007,
     541, -1007, -1007, -1007, -1007,   366, -1007, -1007,   366,   265,
   -1007,   265,   265,   265,   978,   265,   654, -1007,   978,   265,
     265,   287,   287,   287,   287,   978, -1007, -1007,   978,   978,
   -1007, -1007, -1007, -1007, -1007,   978, -1007,   265, -1007, -1007,
     265,   265,   265,   265,   265,   265, -1007,   978,   265,   261,
   -1007, -1007,   265,   265, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007,    11, -1007,    63, -1007,    11,   261, -1007,   317,
     317,   203, -1007, -1007,   230, -1007,   240,   241,   653, -1007,
     444, -1007, -1007, -1007, -1007,   657,   484, -1007, -1007, -1007,
     660,   661, -1007, -1007, -1007,   265,   978,   265, -1007,   978,
     265,   265,   287,   287,   265,   265, -1007, -1007,   978, -1007,
     265,   265,   265,   265, -1007,   265,   265,   261, -1007,   265,
     265, -1007,    63,   645,   655,   664,   252,    63,   658,   317,
     317, -1007,   366,   366,   548, -1007,   366, -1007,   366, -1007,
      41, -1007, -1007, -1007, -1007,   265, -1007,   978, -1007, -1007,
     265,   265,   265,   265, -1007, -1007, -1007,   265, -1007,   265,
     265,   261,   265, -1007, -1007,   263, -1007,    63,   547,   366,
     366,   263,   136, -1007, -1007,   665,   663, -1007,   666,   670,
   -1007,   667, -1007,   978,   265,   265,   265,   265, -1007, -1007,
     265,   265, -1007,   265,   366,   366,   675,   671, -1007,   172,
     172,    19,   672, -1007,   366, -1007, -1007,   366,   639,   265,
     265, -1007, -1007,   265, -1007,   232,   172,   561,    63,   136,
     136,   679,   685,   978, -1007, -1007,   265,   265, -1007,   677,
     686,   678, -1007, -1007,   646, -1007,    63,   569,   136,   978,
   -1007, -1007,   684,   265,   136, -1007,   692,   263,   366,   697,
     693,   261, -1007,   263,   701, -1007
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   315,    24,   125,     0,   325,
       0,   311,     0,     0,   164,   165,   166,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   303,     0,
     306,   308,   310,   305,     0,     0,     0,     0,     0,   151,
       0,   319,     8,     5,    20,     0,    11,    12,    10,    36,
      31,    32,    33,    34,    35,    14,    13,    15,    17,    16,
      18,    19,    74,    76,    77,    78,    79,    80,    81,   119,
     120,   121,   123,    82,    83,   104,   101,   102,   103,   100,
     124,    99,    84,    85,    87,    88,    90,    89,    91,    93,
      94,    96,    95,   109,   176,   110,   182,   111,   184,   112,
     113,   114,   193,   115,    98,    97,    86,    75,   122,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    92,   105,   106,   107,   116,   117,   108,   118,     0,
      30,     0,    26,    27,    57,    37,    29,    49,    49,    28,
      55,     0,     0,     0,   322,   321,   323,   324,     0,     0,
       0,     0,     0,   403,   402,   404,   376,   379,   438,   439,
       0,   443,     0,     0,   335,   347,   337,   372,   374,   336,
       0,     0,   401,     0,   437,   168,   316,     0,     0,   326,
       0,     0,     0,     0,   312,     0,     0,     0,     0,   395,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     293,   294,     0,   304,   338,   339,   307,   309,     0,     0,
     297,   298,     0,   236,   237,     0,   320,     0,   313,     2,
      23,   313,     0,     0,     0,     0,     0,     0,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   319,   186,   186,   186,
     195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,    46,
      56,     0,    72,   400,     0,     0,     0,     0,   353,     0,
       0,     0,     0,   438,   439,     0,   405,   407,   409,   411,
     413,   416,   421,   422,   426,   429,   433,   439,   373,   375,
     434,   435,   436,   380,   377,   381,   378,   371,     0,   441,
       0,     0,   167,     0,   386,     0,     0,     0,   448,   449,
     370,   317,   392,     0,   327,   360,     0,     0,     0,     0,
       0,     0,     0,   397,   311,     0,     0,     0,     0,     0,
       0,     0,     0,   292,   329,   330,     0,     0,     0,     0,
       0,   328,     0,     0,     0,     0,     0,     0,     0,     4,
      25,     8,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
       0,   171,   171,     0,   287,     0,     0,     0,     0,   187,
     178,     0,     0,   196,     0,     0,     0,     0,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,     0,     0,
       0,     0,     0,     0,    50,     0,    72,    48,    45,    53,
      54,    51,    52,   398,     0,     0,     0,     0,   355,   390,
       0,     0,   440,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   421,   445,   446,   447,   382,
     444,     0,     0,   368,   318,     0,     0,   345,     0,   343,
     346,   364,   344,   367,     0,     0,     0,     0,   392,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   362,     0,   282,   153,     0,
     154,   152,     0,     0,   144,     0,     0,     0,   235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   285,     0,     0,     0,     0,   179,   180,
       0,     0,     0,     0,   286,     0,   239,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   402,     0,   278,
     279,   401,     0,    72,    72,    42,    42,     0,    47,     0,
     354,     0,     0,   356,     0,     0,   408,     0,   410,   412,
     414,   415,   417,   418,   419,   420,   427,   428,   423,   424,
     425,   431,   432,   430,   442,   383,   369,     0,     0,   388,
       0,     0,   314,   366,   143,   340,   342,   341,     0,     0,
       0,     0,     0,   203,   204,     0,   159,     0,     0,     0,
     396,     0,     0,     0,     0,     0,   200,     0,     0,     0,
     363,   361,   282,   282,     0,     0,     0,     0,     0,   189,
       0,   141,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,   172,     0,     0,     0,     0,     0,
       0,     0,     0,   181,     0,     0,     0,   190,     0,     0,
     240,     0,     0,     0,     0,   259,     0,   259,     0,     0,
       0,     0,     0,     0,     0,    58,    40,    39,     0,    72,
      72,    69,    71,     0,   399,   138,     0,     0,   389,   393,
       0,     0,     0,     0,     0,     0,     0,   156,   155,   202,
       0,     0,     0,     0,     0,     0,   349,     0,     0,   201,
     384,   283,   284,   288,     0,     0,   352,   188,     0,     0,
       0,     0,     0,     0,     0,     0,   130,   131,     0,     0,
       0,     0,     0,     0,     0,   142,   132,     0,   134,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   290,   289,   149,   331,   333,   332,   334,   148,
     150,   392,     0,     0,     0,   194,     0,     0,   259,     0,
       0,   259,     0,     0,   260,   261,     0,     0,   262,     0,
       0,   243,     0,     0,     0,     0,   259,     0,     0,     0,
       0,     0,     0,    64,    59,    43,    41,    44,     0,    73,
       0,   348,   357,   406,   387,     0,   391,   365,     0,     0,
     158,     0,     0,     0,     0,     0,     0,   351,     0,     0,
       0,     0,     0,     0,     0,     0,   126,   127,     0,     0,
     145,   146,   147,   133,   135,     0,   137,     0,   208,   209,
       0,     0,     0,     0,     0,     0,   291,     0,     0,     0,
     191,   192,     0,     0,   224,   275,   276,   231,   225,   226,
     277,   227,   257,   232,     0,   228,   257,     0,   229,     0,
       0,     0,   270,   269,   272,   271,     0,     0,     0,   280,
     281,    63,    60,    61,    62,     0,    72,    68,    67,    70,
       0,     0,   157,   160,   175,     0,     0,     0,   350,     0,
       0,     0,     0,     0,     0,     0,   139,   128,     0,   136,
       0,     0,     0,     0,   162,     0,     0,     0,   358,     0,
       0,   140,     0,     0,   249,     0,   246,     0,     0,     0,
       0,   267,     0,     0,     0,   263,     0,   265,     0,   234,
       0,    38,   385,   394,   174,     0,   199,     0,   295,   296,
       0,     0,     0,     0,   129,   206,   207,     0,   163,     0,
       0,     0,   183,   358,   197,   254,   258,     0,     0,     0,
       0,   254,     0,   230,   233,     0,     0,   273,     0,     0,
      66,     0,   173,     0,     0,     0,     0,     0,   161,   169,
       0,     0,   359,   185,     0,     0,     0,   250,   253,   247,
     248,     0,     0,   268,     0,   264,   266,     0,     0,     0,
       0,   301,   302,     0,   358,   255,   256,     0,     0,     0,
       0,     0,     0,     0,   299,   300,     0,   177,   241,   251,
       0,     0,   274,    65,     0,   170,     0,     0,     0,     0,
     252,   242,     0,     0,     0,   198,     0,   254,     0,     0,
       0,     0,   245,   254,     0,   244
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1007, -1007, -1007,   508,   -54,    17,   530, -1007, -1007,   216,
      -1, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
     153, -1007, -1007, -1007,   609,    57, -1007, -1007, -1007, -1007,
   -1007, -1007,  -110, -1007,  -295, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007,   349, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,    99, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007, -1007, -1007, -1007,  -159,  -709,   -79,   -78, -1003,
   -1007,  -794, -1006,  -173,  -710,  -591,  -843,  -807,  -923,  -703,
     -88,  -429,  -839,  -286, -1007, -1007, -1007, -1007, -1007, -1007,
   -1007, -1007,   414, -1007, -1007, -1007,   404,   -40, -1007,   192,
     393,    53,    52, -1007,   -23,  -535, -1007, -1007, -1007,     8,
   -1007, -1007, -1007,   406, -1007,  1029,  -837, -1007,  -992, -1007,
    -189, -1007,  -323, -1007,   440, -1007,    14,   614,   622, -1007,
    -348,  -316,   461,  -178,  -190,  -214, -1007,  -192, -1007,  -224,
    2002,   335,   367,   613,   -52,    25,   326,   329,   328,   333,
     -66,  -333, -1007,  -474,  -481,  1691,  -595,  -440,   617
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    62,     3,     4,    63,    64,    65,   392,
     154,    66,    67,     9,    68,    69,    70,    71,    72,    73,
     759,    74,    75,    76,   298,   302,    77,    78,    79,   873,
     874,   966,   762,   763,   457,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   667,
     104,   105,   106,   107,   108,   109,   110,   581,   111,   112,
     113,   114,   589,   734,   115,   116,   117,   118,   430,   119,
     120,   845,   121,   122,   434,   123,   124,   125,   126,   127,
     576,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   235,   597,   861,   862,   865,  1004,
    1005,   859,  1076,  1002,   857,   858,   951,   952,   953,   848,
     852,   849,  1006,   684,   141,   142,   143,   144,   145,   146,
     147,   148,   205,   149,   197,   505,   237,   182,   200,   353,
     379,   373,   834,   835,   836,   223,   654,   507,   508,   184,
     765,   212,   215,   538,   380,   609,   308,   468,  1042,   354,
     374,   375,   837,   511,   838,   185,   186,   187,   188,   189,
     535,   344,   345,   190,   347,   351,   310,   513,   366,   208,
     163,   304,   191,   192,   955,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   193,   194,   499,   500
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     183,   195,   636,   637,   340,   383,   355,   462,   238,   222,
     495,   638,   639,   640,   691,   156,   362,   754,   159,   608,
     395,   396,   397,   398,  1008,    11,   956,   957,   534,   381,
     510,   503,   958,   961,   959,   962,   856,   863,   376,   850,
     851,   216,  1060,   622,  1077,  1081,   866,   867,   173,   174,
     175,  1073,   645,   338,   682,   162,   937,   224,   201,   202,
     233,   234,   469,   225,   164,   165,   166,   167,   168,   470,
     169,   333,   334,   950,   162,   348,  1097,   683,     1,   239,
     349,   339,   241,  1099,   164,   165,   166,   167,   425,   770,
     152,   169,     5,   153,   680,  1109,   473,   173,   174,   175,
     506,     7,  1107,   312,     6,   168,   169,   959,   171,   172,
     438,   439,   479,   480,   173,   174,   175,   315,   170,   963,
     506,  1129,   455,   171,   172,    10,   301,  1134,   173,   174,
     175,   303,   442,   443,   173,   174,   175,   481,   482,   934,
     473,   863,   879,   517,   880,   474,   632,   633,   634,   635,
     173,   493,   175,   941,   623,   860,   943,   949,   796,   945,
     342,   618,   650,  1045,  -438,   959,   333,   334,  1051,  -438,
     959,   553,   554,   555,   556,   446,   447,   646,   151,   376,
     360,   313,   314,   180,   181,   656,   776,   536,   681,   157,
     650,   371,   536,   533,   378,   169,   479,   649,   346,   381,
     679,  1127,   313,   314,   180,   181,   533,   312,  1133,  1082,
     959,   543,   171,   172,    12,   176,   177,   178,   179,   180,
     181,   481,   482,   173,   174,   175,   477,   478,   348,   169,
     496,   497,   498,   349,   150,   376,   155,   483,   484,   488,
     489,   312,   335,   336,   490,   454,   171,   172,   460,   461,
     485,   486,   487,   533,   647,   648,  1110,  1111,   659,   860,
     158,   959,   897,  1011,   899,   900,   650,  1012,   903,   904,
     292,   293,   294,   295,   296,  1122,   860,  1120,   160,   959,
     598,   599,   600,   601,   602,   603,   604,   605,   606,  1013,
     162,   494,   161,  1014,   501,   854,   751,   752,   753,   855,
    1015,  1017,   483,   484,  1016,  1018,   313,   314,   180,   181,
     930,   935,   936,   222,   196,   853,   633,  1126,   756,   757,
     199,  1130,  1049,  1050,   164,   165,   166,   167,   536,   695,
     696,   697,   698,  1074,  1075,   519,   520,   238,   176,   177,
     178,   327,   180,   181,   701,   703,   169,  1003,   173,   174,
     175,  1003,   173,   306,   175,   456,   458,   540,   170,   204,
     544,   509,   206,   171,   172,   207,   982,   983,   984,   985,
     335,   336,   337,   209,   173,   174,   175,   431,   432,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   210,   355,   791,   792,   613,   614,
     615,   616,   211,   585,   173,   607,   175,   213,   550,   376,
     516,   630,   631,   214,   169,   751,   752,   753,   624,   625,
     220,   221,   583,   226,   227,   169,   312,   228,   229,   230,
     232,   171,   172,   231,   236,   594,   853,   312,   297,   300,
     301,   343,   171,   172,   346,   459,   363,  1030,  1031,   365,
     651,   368,   414,   367,   387,   176,   177,   178,   179,   180,
     181,   169,   417,   660,   876,   877,   571,   415,   222,   416,
     418,   801,   802,   312,   419,   420,   421,   422,   171,   172,
     429,   433,   440,   441,   437,   448,   444,   807,   445,   809,
     449,   687,   967,   661,   662,   450,   451,   452,   453,   665,
     668,   455,   464,   463,   465,   471,   475,   467,   677,   222,
     472,   476,   491,   502,   504,   515,   655,   840,   525,   528,
    1009,  1010,   657,   533,   690,   313,   314,   180,   181,   305,
     531,   548,   551,   537,   552,   311,   313,   314,   180,   181,
     586,   588,   536,   575,   580,   968,   572,   578,   590,   341,
     717,   718,   970,   591,   593,   971,   595,   224,   596,   612,
     755,   727,   617,   225,   352,   356,   303,   620,  1079,  1080,
     767,   644,   313,   314,   180,   181,   881,   650,   652,   369,
    1053,  1054,   372,   377,   658,   382,   352,   670,   659,   341,
     685,   686,   674,   693,  1096,   907,   772,   390,   773,   386,
    1095,   694,   716,   719,   724,   728,   774,   775,   733,   729,
     699,   700,   702,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   758,   764,   768,   761,   740,
     738,   769,   771,   794,   795,   776,   786,   648,   777,   778,
     731,   788,   790,   793,   780,   781,   782,   842,   864,   868,
     785,   869,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   799,   798,   800,   822,
     831,  1021,   832,   833,   870,   871,   805,   806,   872,   808,
     428,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   875,   878,   882,   884,   885,   886,   887,
     828,   888,   940,   897,   926,   942,   944,   946,   947,   965,
    1019,  1020,   843,   844,   978,  1022,  1023,  1046,  1057,  1047,
     514,  1048,  1052,  1078,   518,  1083,  1085,  1084,   522,   523,
    1086,  1087,  1097,   526,   527,  1098,  1100,  1108,  1103,  1112,
    1113,  1116,  1118,  1117,  1119,  1121,   539,   542,  1124,   391,
    1132,   545,   546,   547,  1102,   377,  1128,   889,  1135,   222,
     222,  1131,   894,   222,   222,   896,   692,   299,   389,   760,
     969,   582,   938,  1007,   939,   898,   309,   948,   524,   730,
     377,   549,   905,   839,   328,   906,   541,   908,   909,   910,
     911,   912,   329,   512,   913,   883,   914,   915,   916,   619,
     627,   492,   626,   628,   922,   222,     0,   224,   224,   629,
     350,   224,   224,   225,   225,   610,     0,   225,   225,     0,
     964,     0,     0,     0,     0,     0,   309,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,     0,     0,     0,     0,   225,
       0,   222,   222,   222,   222,     0,     0,     0,     0,     0,
       0,   976,     0,   653,     0,   979,     0,     0,     0,     0,
       0,     0,   986,     0,     0,   987,   988,     0,     0,     0,
       0,   669,   989,   672,   673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,   224,
     224,   224,   224,     0,     0,   225,   225,   225,   225,     0,
     309,     0,     0,     0,   377,   518,   518,   377,   377,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   377,     0,
       0,     0,   222,   222,   721,     0,   723,     0,     0,     0,
       0,     0,     0,  1025,   732,     0,  1027,     0,     0,   737,
    1055,  1056,     0,     0,  1058,  1034,  1059,     0,     0,     0,
       0,     0,     0,   309,     0,     0,     0,     0,     0,     0,
       0,     0,   309,   309,     0,   309,     0,     0,   766,     0,
     224,   224,     0,     0,     0,     0,   225,   225,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1101,     0,     0,     0,   168,   169,     0,     0,
    1088,     0,     0,     0,     0,     0,     0,     0,     0,   170,
       0,     0,     0,     0,   171,   172,     0,     0,     0,     0,
       0,   611,     0,     0,     0,   173,   174,   175,   352,     0,
     352,     0,     0,     0,     0,     0,     0,     0,     0,   309,
    1114,     0,     0,     0,     0,   164,   165,   166,   167,   827,
       0,     0,   829,   830,     0,     0,  1123,   514,   841,     0,
       0,     0,     0,     0,     0,     0,   847,   169,   610,   610,
     610,   610,     0,     0,     0,     0,   610,   610,     0,   170,
       0,   506,     0,     0,   171,   172,     0,     0,     0,     0,
       0,     0,   309,   309,     0,   173,   174,   175,     0,   611,
       0,     0,   309,   309,     0,   309,   176,   177,   178,   179,
     180,   181,     0,     0,     0,     0,     0,     0,   309,   309,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   352,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   307,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   164,   165,   166,   167,
     928,   929,     0,     0,     0,     0,   176,   177,   178,   179,
     180,   181,     0,   610,     0,     0,   610,   168,   169,   610,
       0,     0,   610,     0,     0,   954,   954,   954,     0,     0,
     170,     0,   370,     0,     0,   171,   172,   164,   165,   166,
     167,     0,     0,     0,     0,     0,   173,   174,   175,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   169,
       0,     0,     0,     0,     0,     0,     0,     0,   309,     0,
       0,   170,     0,     0,   309,   309,   171,   172,   309,     0,
       0,   309,     0,     0,     0,     0,   999,   173,   607,   175,
       0,   309,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,     0,   610,   610,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     309,   309,     0,   309,   309,     0,   466,   176,   177,   666,
     179,   180,   181,     0,     0,     0,     0,     0,     0,     0,
       0,   309,     0,     0,   611,   611,   611,   611,     0,     0,
       0,     0,   611,   611,  1041,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   610,   610,   176,   177,
     178,   179,   180,   181,     0,     0,     0,  1061,     0,   521,
       0,     0,     0,     0,   309,   309,   309,   309,   529,   530,
     309,   532,     0,     0,     0,     0,     0,     0,  1071,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   309,   309,   309,   309,
       0,   309,   309,   309,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   611,   309,
     309,     0,     0,     0,     0,     0,   954,   954,     0,   611,
       0,     0,   611,     0,     0,   611,     0,     0,   611,     0,
       0,     0,     0,     0,   960,   954,     0,     0,     0,     0,
       0,   954,     0,     0,     0,   621,     0,     0,   954,     0,
       0,     0,   309,     0,   309,   309,   309,     0,   309,     0,
       0,     0,   309,   309,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     309,     0,     0,   309,   309,   309,   309,   309,   309,     0,
       0,   309,     0,     0,     0,   309,   309,     0,   663,   664,
       0,     0,     0,     0,     0,   671,     0,   960,   675,   676,
       0,   678,   611,   611,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   688,   689,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   309,     0,
     309,     0,     0,   309,   309,     0,     0,   309,   309,     0,
       0,     0,     0,   309,   309,   309,   309,     0,   309,   309,
       0,     0,   309,   309,     0,   960,     0,     0,     0,     0,
     960,     0,   611,   611,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   309,     0,
       0,     0,     0,   309,   309,   309,   309,     0,     0,     0,
     309,     0,   309,   309,     0,   309,     0,     0,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   309,   309,   309,
     309,     0,     0,   309,   309,     0,   309,     0,     0,     0,
       0,     0,     0,     0,   779,     0,     0,     0,     0,     0,
     783,   784,   309,   309,   787,     0,   309,   789,     0,     0,
       0,   960,     0,     0,     0,     0,     0,   797,     0,   309,
     309,     0,     0,     0,     0,     0,     0,     0,     0,   960,
       0,     0,     0,     0,     0,     0,   309,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   823,   824,     0,   825,
     826,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     890,   891,   892,   893,     0,     0,   895,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,   919,   920,   921,     0,   923,   924,   925,
     326,   330,   331,   332,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   931,   932,   933,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   972,     0,
     973,   974,   975,     0,   977,     0,     0,     0,   980,   981,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   990,     0,     0,   991,
     992,   993,   994,   995,   996,     0,     0,   998,     0,     0,
       0,  1000,  1001,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   326,     0,
       0,   326,   326,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   330,  1024,     0,  1026,     0,     0,  1028,
    1029,     0,     0,  1032,  1033,     0,     0,     0,     0,  1035,
    1036,  1037,  1038,     0,  1039,  1040,     0,     0,  1043,  1044,
     198,     0,   203,     0,   326,     0,     0,   326,     0,     0,
       0,     0,     0,     0,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,  1062,     0,     0,     0,     0,  1064,
    1065,  1066,  1067,     0,     0,     0,  1068,     0,  1069,  1070,
       0,  1072,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1089,  1090,  1091,  1092,     0,     0,  1093,
    1094,     0,  1072,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,  1105,
       0,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1115,  1072,     0,     0,     0,
       0,   326,   326,   326,   326,     0,     0,     0,     0,     0,
       0,     0,  1125,     0,     0,     0,     0,     0,     0,     0,
       0,   326,   326,     0,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   641,
     642,   643,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,   357,   358,   359,     0,   326,   361,     0,     0,
     364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   326,     0,     0,     0,     0,     0,
     384,   385,     0,     0,   326,     0,     0,     0,     0,   388,
       0,     0,     0,     0,   393,   394,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   413,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   423,   424,   426,   427,     0,     0,
       0,     0,     0,   435,   436,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   326,
     326,   326,     0,     0,     0,     0,     0,     0,     0,   326,
     326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   326,   326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   573,   574,     0,
     577,     0,   579,     0,     0,     0,     0,   584,     0,     0,
     587,     0,     0,     0,     0,     0,   592,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   326,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    -9,     0,     0,     0,     0,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
      23,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,     0,    26,    -9,     0,   326,
     326,   326,     0,   326,     0,     0,     0,     0,     0,   326,
       0,     0,     0,     0,     0,     0,   326,     0,   720,   326,
     722,    27,     0,   725,   726,     0,     6,     0,     0,     0,
       0,     0,   735,   736,     0,     0,    28,   739,     0,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,     0,
       0,    29,    30,     0,     0,     0,     0,    31,    32,    33,
       0,     0,     0,    34,    35,    36,     0,     0,    37,    38,
      39,    40,    41,     0,     0,     0,     0,    42,    43,    44,
      45,     0,    46,    47,    48,    49,    50,    51,    52,    53,
       0,     0,     0,    54,    55,     0,     0,    56,    57,    58,
      59,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    60,    61,     0,     0,     0,     0,     0,   803,
     804,     0,     0,   326,   326,     0,     0,   326,     0,   326,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     326,   326,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,   240,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,   326,   326,     0,     0,     0,
       0,     0,     0,     0,     0,   326,     0,     0,   326,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,
     326,   326,    -8,    -8,     0,     0,    -8,    -8,     0,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,   326,
      -8,     0,    -8,    -8,     0,   326,     0,     0,     0,   326,
       0,     0,     0,     0,   917,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    -8,     0,     0,
       0,     0,     1,     0,   927,     0,     0,     0,     0,     0,
       0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,
       0,     0,     0,     0,     0,    -8,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     0,     0,     0,     0,     0,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,    23,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,     0,    26,   390,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    30,     0,
       0,     0,     0,    31,    32,    33,     0,     0,     0,    34,
      35,    36,     0,     0,    37,    38,    39,    40,    41,     0,
       0,     0,     0,    42,    43,    44,    45,     0,    46,    47,
      48,    49,    50,    51,    52,    53,     0,     0,     0,    54,
      55,     0,     0,    56,    57,    58,    59,    13,    14,    15,
      16,    17,    18,    19,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,     0,    22,     0,     0,    23,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    25,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,   242,   243,   244,   245,
     246,   247,     0,    28,     0,     0,     0,   248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
       0,     0,     0,     0,    31,    32,    33,     0,     0,     0,
      34,    35,    36,     0,     0,    37,    38,    39,    40,    41,
       0,     0,     0,     0,    42,    43,    44,    45,     0,    46,
      47,    48,    49,    50,    51,    52,    53,     0,     0,     0,
      54,    55,     0,     0,    56,    57,    58,    59,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,     0,   263,   264,   265,   266,     0,     0,
       0,   267,   268,   269,     0,     0,     0,   270,   271,    60,
      61,     0,     0,     0,   272,   273,   274,   275,     0,     0,
       0,     0,   276,     0,     0,     0,     0,     0,     0,     0,
       0,   277,   278,   279,     0,     0,   280,   281,     0,     0,
       0,     0,   282,     0,     0,     0,     0,     0,     0,     0,
     283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   284,   285,   286,   287,   288,
     289,   290,   291
};

static const yytype_int16 yycheck[] =
{
      23,    24,   483,   484,   182,   219,   198,   302,    62,    49,
     343,   485,   486,   487,   549,    16,   206,   608,    19,   448,
     244,   245,   246,   247,   947,     8,   869,   870,   376,   218,
     353,   347,   871,     1,   871,     3,   745,   747,   216,   742,
     743,    42,     1,    59,  1047,  1051,   749,   750,    87,    88,
      89,  1043,   492,    59,    64,    59,   850,    49,    43,    44,
     187,   188,    57,    49,    37,    38,    39,    40,    58,    64,
      59,    49,    50,   867,    59,    47,    57,    87,    91,    62,
      52,    87,    65,    64,    37,    38,    39,    40,    92,    66,
      87,    59,     0,    90,   534,  1098,    73,    87,    88,    89,
      73,    14,  1094,    71,    91,    58,    59,   944,    76,    77,
     187,   188,    54,    55,    87,    88,    89,   169,    71,    87,
      73,  1127,    17,    76,    77,   170,    21,  1133,    87,    88,
      89,   170,   187,   188,    87,    88,    89,    79,    80,   848,
      73,   851,    62,   357,    64,    78,   479,   480,   481,   482,
      87,   341,    89,   856,   170,   746,   859,   866,    60,   862,
     183,   456,    64,  1002,    47,  1002,    49,    50,  1007,    52,
    1007,   395,   396,   397,   398,   187,   188,   493,    87,   357,
     203,   170,   171,   172,   173,   508,    60,   377,   536,    87,
      64,   214,   382,    54,   217,    59,    54,    55,    59,   388,
     533,  1124,   170,   171,   172,   173,    54,    71,  1131,  1052,
    1047,    59,    76,    77,    63,   168,   169,   170,   171,   172,
     173,    79,    80,    87,    88,    89,    81,    82,    47,    59,
      49,    50,    51,    52,   170,   413,    90,    70,    71,    67,
      68,    71,    49,    50,    72,   297,    76,    77,   300,   301,
      83,    84,    85,    54,    64,    65,  1099,  1100,    59,   850,
      87,  1098,    60,    60,   799,   800,    64,    64,   803,   804,
      22,    23,    24,    25,    26,  1118,   867,  1116,    87,  1116,
     439,   440,   441,   442,   443,   444,   445,   446,   447,    59,
      59,   343,    87,    63,   346,   180,   181,   182,   183,   184,
      60,    60,    70,    71,    64,    64,   170,   171,   172,   173,
     845,   177,   178,   353,    77,   744,   649,  1124,   613,   614,
      53,  1128,    70,    71,    37,    38,    39,    40,   518,   553,
     554,   555,   556,    70,    71,   358,   359,   391,   168,   169,
     170,   171,   172,   173,   558,   559,    59,   942,    87,    88,
      89,   946,    87,    88,    89,   298,   299,   380,    71,    95,
     383,   353,    94,    76,    77,    63,   901,   902,   903,   904,
      49,    50,    51,    96,    87,    88,    89,   278,   279,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,    96,   587,   682,   683,   450,   451,
     452,   453,    59,   426,    87,    88,    89,    40,   391,   587,
     357,   477,   478,    59,    59,   181,   182,   183,   470,   471,
      90,   170,   423,   100,   100,    59,    71,    96,    96,    87,
      96,    76,    77,    87,    36,   436,   865,    71,    18,    69,
      21,    54,    76,    77,    59,    90,   170,   982,   983,    59,
     502,   170,    63,    97,   185,   168,   169,   170,   171,   172,
     173,    59,     4,   515,   759,   760,   413,    96,   508,    96,
      96,   695,   696,    71,    63,    96,     4,     4,    76,    77,
      29,    93,   187,   187,    63,   188,   187,   701,   187,   703,
      48,   543,    90,   516,   517,    19,    19,    19,    19,   522,
     523,    17,    64,    60,    63,    59,    74,    63,   531,   549,
      60,    75,    87,    54,   167,    59,   508,   731,   170,    64,
     949,   950,   508,    54,   547,   170,   171,   172,   173,   162,
      64,   186,   171,    59,   171,   168,   170,   171,   172,   173,
      87,    27,   732,    63,    63,   878,   170,   170,    96,   182,
     573,   574,   885,    96,   170,   888,   170,   549,   175,    19,
     612,   584,    61,   549,   197,   198,   170,   170,  1049,  1050,
     622,    60,   170,   171,   172,   173,   766,    64,    60,   212,
    1009,  1010,   215,   216,    56,   218,   219,    60,    59,   222,
      59,    59,   170,   170,  1075,   809,   648,    62,   650,   232,
    1074,   170,    63,   170,   170,   170,   658,   659,    28,   170,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,    20,    60,    57,    87,   175,
     170,    60,   170,   685,   686,    60,    60,    65,   661,   662,
     587,    64,    55,    60,   667,   668,   669,    96,   180,    59,
     673,    59,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   170,   690,   170,   170,
     170,   966,   170,   170,    59,    56,   699,   700,    16,   702,
     276,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,    87,    69,    60,    55,    64,    60,    57,
     723,    54,   179,    60,   170,    56,    56,    56,    56,    15,
      57,    54,   735,   736,    60,    55,    55,    72,   170,    64,
     353,    57,    64,   176,   357,    60,    60,    64,   361,   362,
      60,    64,    57,   366,   367,    64,    64,   176,    99,    60,
      55,    64,    64,    57,    98,   176,   379,   380,    64,   241,
      57,   384,   385,   386,  1087,   388,    64,   780,    57,   799,
     800,    64,   785,   803,   804,   788,   550,   158,   238,   616,
     880,   422,   851,   946,   852,   798,   163,   865,   364,   587,
     413,   388,   805,   731,   170,   808,   380,   810,   811,   812,
     813,   814,   170,   353,   817,   770,   819,   820,   821,   464,
     474,   340,   473,   475,   827,   845,    -1,   799,   800,   476,
     193,   803,   804,   799,   800,   448,    -1,   803,   804,    -1,
     872,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   845,    -1,    -1,    -1,    -1,    -1,   845,
      -1,   901,   902,   903,   904,    -1,    -1,    -1,    -1,    -1,
      -1,   894,    -1,   506,    -1,   898,    -1,    -1,    -1,    -1,
      -1,    -1,   905,    -1,    -1,   908,   909,    -1,    -1,    -1,
      -1,   524,   915,   526,   527,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   927,    -1,    -1,    -1,    -1,   901,
     902,   903,   904,    -1,    -1,   901,   902,   903,   904,    -1,
     307,    -1,    -1,    -1,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,    -1,
      -1,    -1,   982,   983,   577,    -1,   579,    -1,    -1,    -1,
      -1,    -1,    -1,   976,   587,    -1,   979,    -1,    -1,   592,
    1012,  1013,    -1,    -1,  1016,   988,  1018,    -1,    -1,    -1,
      -1,    -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   369,   370,    -1,   372,    -1,    -1,   621,    -1,
     982,   983,    -1,    -1,    -1,    -1,   982,   983,    -1,    -1,
      -1,    -1,    -1,    -1,  1027,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1084,    -1,    -1,    -1,    58,    59,    -1,    -1,
    1063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    77,    -1,    -1,    -1,    -1,
      -1,   448,    -1,    -1,    -1,    87,    88,    89,   701,    -1,
     703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
    1103,    -1,    -1,    -1,    -1,    37,    38,    39,    40,   722,
      -1,    -1,   725,   726,    -1,    -1,  1119,   730,   731,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   739,    59,   741,   742,
     743,   744,    -1,    -1,    -1,    -1,   749,   750,    -1,    71,
      -1,    73,    -1,    -1,    76,    77,    -1,    -1,    -1,    -1,
      -1,    -1,   519,   520,    -1,    87,    88,    89,    -1,   526,
      -1,    -1,   529,   530,    -1,   532,   168,   169,   170,   171,
     172,   173,    -1,    -1,    -1,    -1,    -1,    -1,   545,   546,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   809,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
     843,   844,    -1,    -1,    -1,    -1,   168,   169,   170,   171,
     172,   173,    -1,   856,    -1,    -1,   859,    58,    59,   862,
      -1,    -1,   865,    -1,    -1,   868,   869,   870,    -1,    -1,
      71,    -1,   213,    -1,    -1,    76,    77,    37,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   665,    -1,
      -1,    71,    -1,    -1,   671,   672,    76,    77,   675,    -1,
      -1,   678,    -1,    -1,    -1,    -1,   929,    87,    88,    89,
      -1,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   947,    -1,   949,   950,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     717,   718,    -1,   720,   721,    -1,   307,   168,   169,   170,
     171,   172,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   738,    -1,    -1,   741,   742,   743,   744,    -1,    -1,
      -1,    -1,   749,   750,   997,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1009,  1010,   168,   169,
     170,   171,   172,   173,    -1,    -1,    -1,  1020,    -1,   360,
      -1,    -1,    -1,    -1,   781,   782,   783,   784,   369,   370,
     787,   372,    -1,    -1,    -1,    -1,    -1,    -1,  1041,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1052,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   823,   824,   825,   826,
      -1,   828,   829,   830,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   845,   846,
     847,    -1,    -1,    -1,    -1,    -1,  1099,  1100,    -1,   856,
      -1,    -1,   859,    -1,    -1,   862,    -1,    -1,   865,    -1,
      -1,    -1,    -1,    -1,   871,  1118,    -1,    -1,    -1,    -1,
      -1,  1124,    -1,    -1,    -1,   466,    -1,    -1,  1131,    -1,
      -1,    -1,   889,    -1,   891,   892,   893,    -1,   895,    -1,
      -1,    -1,   899,   900,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     917,    -1,    -1,   920,   921,   922,   923,   924,   925,    -1,
      -1,   928,    -1,    -1,    -1,   932,   933,    -1,   519,   520,
      -1,    -1,    -1,    -1,    -1,   526,    -1,   944,   529,   530,
      -1,   532,   949,   950,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   545,   546,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   975,    -1,
     977,    -1,    -1,   980,   981,    -1,    -1,   984,   985,    -1,
      -1,    -1,    -1,   990,   991,   992,   993,    -1,   995,   996,
      -1,    -1,   999,  1000,    -1,  1002,    -1,    -1,    -1,    -1,
    1007,    -1,  1009,  1010,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1025,    -1,
      -1,    -1,    -1,  1030,  1031,  1032,  1033,    -1,    -1,    -1,
    1037,    -1,  1039,  1040,    -1,  1042,    -1,    -1,    -1,    -1,
    1047,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1064,  1065,  1066,
    1067,    -1,    -1,  1070,  1071,    -1,  1073,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   665,    -1,    -1,    -1,    -1,    -1,
     671,   672,  1089,  1090,   675,    -1,  1093,   678,    -1,    -1,
      -1,  1098,    -1,    -1,    -1,    -1,    -1,   688,    -1,  1106,
    1107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1116,
      -1,    -1,    -1,    -1,    -1,    -1,  1123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   717,   718,    -1,   720,
     721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   738,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     781,   782,   783,   784,    -1,    -1,   787,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   823,   824,   825,   826,    -1,   828,   829,   830,
     169,   170,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   845,   846,   847,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   889,    -1,
     891,   892,   893,    -1,   895,    -1,    -1,    -1,   899,   900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   917,    -1,    -1,   920,
     921,   922,   923,   924,   925,    -1,    -1,   928,    -1,    -1,
      -1,   932,   933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,   300,   301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,   975,    -1,   977,    -1,    -1,   980,
     981,    -1,    -1,   984,   985,    -1,    -1,    -1,    -1,   990,
     991,   992,   993,    -1,   995,   996,    -1,    -1,   999,  1000,
      28,    -1,    30,    -1,   343,    -1,    -1,   346,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,  1025,    -1,    -1,    -1,    -1,  1030,
    1031,  1032,  1033,    -1,    -1,    -1,  1037,    -1,  1039,  1040,
      -1,  1042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1064,  1065,  1066,  1067,    -1,    -1,  1070,
    1071,    -1,  1073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1089,  1090,
      -1,    -1,  1093,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1106,  1107,    -1,    -1,    -1,
      -1,   450,   451,   452,   453,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   200,   201,   202,    -1,   515,   205,    -1,    -1,
     208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,    -1,    -1,    -1,    -1,    -1,
     228,   229,    -1,    -1,   543,    -1,    -1,    -1,    -1,   237,
      -1,    -1,    -1,    -1,   242,   243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   272,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,   281,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   612,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   622,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   648,
     649,   650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   658,
     659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,    -1,   415,   416,    -1,
     418,    -1,   420,    -1,    -1,    -1,    -1,   425,    -1,    -1,
     428,    -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    -1,    61,    62,    -1,   868,
     869,   870,    -1,   872,    -1,    -1,    -1,    -1,    -1,   878,
      -1,    -1,    -1,    -1,    -1,    -1,   885,    -1,   576,   888,
     578,    86,    -1,   581,   582,    -1,    91,    -1,    -1,    -1,
      -1,    -1,   590,   591,    -1,    -1,   101,   595,    -1,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,    -1,
      -1,   116,   117,    -1,    -1,    -1,    -1,   122,   123,   124,
      -1,    -1,    -1,   128,   129,   130,    -1,    -1,   133,   134,
     135,   136,   137,    -1,    -1,    -1,    -1,   142,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
      -1,    -1,    -1,   158,   159,    -1,    -1,   162,   163,   164,
     165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   197,   198,    -1,    -1,    -1,    -1,    -1,   697,
     698,    -1,    -1,  1012,  1013,    -1,    -1,  1016,    -1,  1018,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1049,  1050,    -1,  1052,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,  1074,  1075,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1084,    -1,    -1,  1087,    -1,
      -1,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
    1099,  1100,    41,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    -1,    -1,   801,   802,    -1,    -1,    -1,    -1,  1118,
      59,    -1,    61,    62,    -1,  1124,    -1,    -1,    -1,  1128,
      -1,    -1,    -1,    -1,   822,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    91,    -1,   842,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,    -1,
      -1,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,    -1,
      -1,    -1,    -1,   142,   143,   144,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,   162,   163,   164,   165,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,   198,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,   101,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,
      -1,    -1,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,    -1,    -1,    -1,   142,   143,   144,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,    -1,
     158,   159,    -1,    -1,   162,   163,   164,   165,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,    -1,    -1,
      -1,   125,   126,   127,    -1,    -1,    -1,   131,   132,   197,
     198,    -1,    -1,    -1,   138,   139,   140,   141,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,   156,   157,    -1,    -1,   160,   161,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   189,   190,   191,   192,   193,
     194,   195,   196
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   200,   203,   204,     0,    91,    14,   201,   212,
     170,   204,    63,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    45,    46,    59,    61,    86,   101,   116,
     117,   122,   123,   124,   128,   129,   130,   133,   134,   135,
     136,   137,   142,   143,   144,   145,   147,   148,   149,   150,
     151,   152,   153,   154,   158,   159,   162,   163,   164,   165,
     197,   198,   202,   205,   206,   207,   210,   211,   213,   214,
     215,   216,   217,   218,   220,   221,   222,   225,   226,   227,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   259,   260,   261,   262,   263,   264,
     265,   267,   268,   269,   270,   273,   274,   275,   276,   278,
     279,   281,   282,   284,   285,   286,   287,   288,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   323,   324,   325,   326,   327,   328,   329,   330,   332,
     170,    87,    87,    90,   209,    90,   209,    87,    87,   209,
      87,    87,    59,   379,    37,    38,    39,    40,    58,    59,
      71,    76,    77,    87,    88,    89,   168,   169,   170,   171,
     172,   173,   336,   343,   348,   364,   365,   366,   367,   368,
     372,   381,   382,   394,   395,   343,    77,   333,   379,    53,
     337,    43,    44,   379,    95,   331,    94,    63,   378,    96,
      96,    59,   350,   381,    59,   351,   209,   379,   379,   379,
      90,   170,   336,   344,   348,   365,   100,   100,    96,    96,
      87,    87,    96,   187,   188,   303,    36,   335,   203,   204,
       1,   204,    30,    31,    32,    33,    34,    35,    41,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   118,   119,   120,   121,   125,   126,   127,
     131,   132,   138,   139,   140,   141,   146,   155,   156,   157,
     160,   161,   166,   174,   189,   190,   191,   192,   193,   194,
     195,   196,    22,    23,    24,    25,    26,    18,   223,   223,
      69,    21,   224,   170,   380,   381,    88,   354,   355,   382,
     375,   381,    71,   170,   171,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   171,   366,   367,
     394,   394,   394,    49,    50,    49,    50,    51,    59,    87,
     372,   381,   343,    54,   370,   371,    59,   373,    47,    52,
     397,   374,   381,   338,   358,   376,   381,   379,   379,   379,
     343,   379,   373,   170,   379,    59,   377,    97,   170,   381,
     354,   343,   381,   340,   359,   360,   372,   381,   343,   339,
     353,   359,   381,   374,   379,   379,   381,   185,   379,   205,
      62,   202,   208,   379,   379,   378,   378,   378,   378,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   379,    63,    96,    96,     4,    96,    63,
      96,     4,     4,   379,   379,    92,   379,   379,   335,    29,
     277,   277,   277,    93,   283,   379,   379,    63,   187,   188,
     187,   187,   187,   188,   187,   187,   187,   188,   188,    48,
      19,    19,    19,    19,   383,    17,   224,   233,   224,    90,
     383,   383,   233,    60,    64,    63,   354,    63,   356,    57,
      64,    59,    60,    73,    78,    74,    75,    81,    82,    54,
      55,    79,    80,    70,    71,    83,    84,    85,    67,    68,
      72,    87,   371,   373,   383,   390,    49,    50,    51,   396,
     397,   383,    54,   370,   167,   334,    73,   346,   347,   348,
     361,   362,   363,   376,   381,    59,   340,   374,   381,   343,
     343,   354,   381,   381,   331,   170,   381,   381,    64,   354,
     354,    64,   354,    54,   369,   369,   373,    59,   352,   381,
     343,   352,   381,    59,   343,   381,   381,   381,   186,   339,
     204,   171,   171,   378,   378,   378,   378,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   340,   170,   379,   379,    63,   289,   379,   170,   379,
      63,   266,   266,   209,   379,   343,    87,   379,    27,   271,
      96,    96,   379,   170,   209,   170,   175,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,    88,   320,   354,
     381,   382,    19,   383,   383,   383,   383,    61,   233,   380,
     170,   354,    59,   170,   383,   383,   386,   385,   387,   388,
     389,   389,   390,   390,   390,   390,   393,   393,   392,   392,
     392,   394,   394,   394,    60,   396,   370,    64,    65,    55,
      64,   383,    60,   381,   345,   348,   361,   365,    56,    59,
     383,   343,   343,   354,   354,   343,   170,   258,   343,   381,
      60,   354,   381,   381,   170,   354,   354,   343,   354,   390,
     396,   369,    64,    87,   322,    59,    59,   383,   354,   354,
     343,   344,   208,   170,   170,   378,   378,   378,   378,   340,
     340,   374,   340,   374,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,    63,   343,   343,   170,
     379,   381,   379,   381,   170,   379,   379,   343,   170,   170,
     338,   340,   381,    28,   272,   379,   379,   381,   170,   379,
     175,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   181,   182,   183,   314,   383,   233,   233,    20,   219,
     219,    87,   231,   232,    60,   349,   381,   383,    57,    60,
      66,   170,   383,   383,   383,   383,    60,   343,   343,   354,
     343,   343,   343,   354,   354,   343,    60,   354,    64,   354,
      55,   322,   322,    60,   383,   383,    60,   354,   343,   170,
     170,   378,   378,   379,   379,   343,   343,   374,   343,   374,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   170,   354,   354,   354,   354,   381,   343,   381,
     381,   170,   170,   170,   341,   342,   343,   361,   363,   341,
     374,   381,    96,   343,   343,   280,   354,   381,   318,   320,
     318,   318,   319,   320,   180,   184,   305,   313,   314,   310,
     314,   305,   306,   313,   180,   307,   318,   318,    59,    59,
      59,    56,    16,   228,   229,    87,   233,   233,    69,    62,
      64,   373,    60,   384,    55,    64,    60,    57,    54,   343,
     354,   354,   354,   354,   343,   354,   343,    60,   343,   344,
     344,   379,   379,   344,   344,   343,   343,   374,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   379,   354,   354,
     354,   354,   343,   354,   354,   354,   170,   379,   381,   381,
     344,   354,   354,   354,   305,   177,   178,   310,   306,   307,
     179,   318,    56,   318,    56,   318,    56,    56,   319,   305,
     310,   315,   316,   317,   381,   383,   315,   315,   321,   355,
     382,     1,     3,    87,   383,    15,   230,    90,   390,   231,
     390,   390,   354,   354,   354,   354,   343,   354,    60,   343,
     354,   354,   344,   344,   344,   344,   343,   343,   343,   343,
     354,   354,   354,   354,   354,   354,   354,   343,   354,   381,
     354,   354,   312,   395,   308,   309,   321,   312,   317,   320,
     320,    60,    64,    59,    63,    60,    64,    60,    64,    57,
      54,   233,    55,    55,   354,   343,   354,   343,   354,   354,
     344,   344,   354,   354,   343,   354,   354,   354,   354,   354,
     354,   381,   357,   354,   354,   321,    72,    64,    57,    70,
      71,   321,    64,   320,   320,   383,   383,   170,   383,   383,
       1,   381,   354,   343,   354,   354,   354,   354,   354,   354,
     354,   381,   354,   357,    70,    71,   311,   308,   176,   393,
     393,   311,   315,    60,    64,    60,    60,    64,   343,   354,
     354,   354,   354,   354,   354,   392,   393,    57,    64,    64,
      64,   383,   390,    99,   354,   354,   354,   357,   176,   308,
     315,   315,    60,    55,   343,   354,    64,    57,    64,    98,
     321,   176,   315,   343,    64,   354,   316,   317,    64,   311,
     316,    64,    57,   317,   311,    57
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   199,   200,   201,   202,   202,   203,   203,   204,   204,
     205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
     205,   206,   206,   206,   207,   208,   209,   209,   210,   211,
     212,   213,   213,   213,   213,   213,   213,   214,   215,   216,
     217,   218,   219,   219,   220,   221,   221,   222,   222,   223,
     223,   224,   225,   226,   226,   226,   226,   227,   228,   228,
     229,   229,   229,   229,   230,   230,   230,   231,   231,   231,
     232,   232,   233,   233,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   235,   236,   236,   236,   236,
     237,   237,   238,   239,   240,   241,   242,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   253,
     253,   254,   255,   255,   255,   256,   256,   257,   257,   258,
     259,   260,   261,   262,   263,   263,   263,   263,   263,   264,
     265,   266,   266,   267,   268,   268,   269,   270,   271,   271,
     272,   272,   273,   274,   275,   276,   277,   277,   278,   279,
     280,   280,   280,   281,   282,   283,   283,   284,   285,   286,
     286,   286,   287,   288,   288,   288,   288,   288,   288,   288,
     289,   289,   290,   290,   290,   290,   290,   290,   290,   290,
     290,   290,   290,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   303,   304,   304,
     304,   305,   306,   306,   307,   307,   308,   308,   308,   309,
     309,   309,   309,   310,   311,   311,   311,   312,   312,   313,
     313,   313,   313,   314,   314,   314,   314,   314,   314,   315,
     315,   316,   317,   317,   317,   318,   318,   319,   320,   320,
     321,   321,   322,   322,   322,   323,   323,   323,   323,   323,
     323,   323,   323,   324,   325,   326,   326,   327,   328,   329,
     329,   329,   329,   330,   330,   330,   330,   330,   330,   330,
     330,   331,   331,   332,   332,   333,   333,   334,   334,   335,
     335,   336,   336,   336,   336,   337,   337,   338,   339,   340,
     340,   341,   341,   342,   342,   343,   343,   343,   344,   344,
     345,   345,   345,   346,   346,   347,   347,   348,   349,   350,
     351,   352,   353,   354,   354,   355,   356,   356,   357,   357,
     358,   359,   359,   360,   361,   361,   362,   363,   364,   364,
     365,   365,   365,   365,   365,   365,   366,   366,   366,   367,
     367,   367,   368,   368,   369,   370,   371,   371,   371,   372,
     372,   373,   374,   375,   376,   377,   377,   378,   379,   379,
     380,   381,   381,   382,   382,   383,   384,   384,   385,   385,
     386,   386,   387,   387,   388,   388,   388,   389,   389,   389,
     389,   389,   390,   391,   391,   391,   391,   392,   392,   392,
     393,   393,   393,   393,   394,   394,   394,   394,   395,   395,
     395,   395,   395,   395,   396,   396,   396,   396,   397,   397
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     8,     9,
       6,     6,     6,     7,     6,     7,     8,     7,     6,     8,
       8,     5,     6,     5,     4,     7,     7,     7,     6,     6,
       6,     1,     4,     4,     4,     6,     6,     8,     7,     1,
       8,    10,     8,     9,     1,     1,     1,     3,     2,    10,
      13,     0,     2,    10,     9,     8,     1,    12,     0,     1,
       0,     1,     1,     9,     1,    10,     0,     1,     6,     5,
       0,     2,     2,     1,     6,     0,     1,     9,    16,     9,
       5,     6,     6,     5,     5,     4,     9,     9,     7,     7,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     7,     7,     7,     7,     7,
       9,     7,     7,     9,     8,     4,     1,     1,     0,     1,
       2,     7,     9,     1,    16,    14,     1,     3,     3,     1,
       3,     5,     7,     5,     0,     2,     2,     0,     2,     0,
       1,     1,     1,     4,     6,     4,     6,     4,     6,     1,
       1,     1,     1,     3,     6,     2,     2,     2,     1,     1,
       1,     1,     0,     2,     2,     4,     4,     3,     6,     6,
       6,     7,     3,     2,     2,     9,     9,     2,     2,    12,
      12,    11,    11,     1,     2,     1,     1,     2,     1,     2,
       1,     0,     1,     0,     5,     0,     1,     0,     1,     0,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     5,
       7,     4,     4,     1,     3,     2,     2,     4,     0,     2,
       1,     3,     2,     3,     1,     4,     2,     1,     3,     4,
       2,     2,     1,     2,     1,     2,     1,     2,     2,     1,
       2,     2,     3,     4,     3,     7,     1,     5,     3,     5,
       3,     5,     1,     4,     7,     0,     3,     2,     3,     5,
       1,     1,     1,     1,     1,     1,     5,     1,     3,     1,
       3,     1,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     1,     1,     3,     3,     3,     1,     3,     3,     1,
       3,     3,     3,     1,     2,     2,     2,     1,     1,     1,
       3,     2,     4,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 660 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3093 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 690 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3101 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 694 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3110 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 698 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3116 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 709 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3125 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 717 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3134 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 725 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3142 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 739 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3150 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 746 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3160 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 754 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3170 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 762 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3179 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 769 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3187 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 772 "CISA.y"
                    {(yyval.string) = "";}
#line 3193 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 772 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3199 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 776 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3208 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 784 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3216 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 789 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3227 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 801 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3236 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 808 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3247 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 815 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3253 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 815 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3259 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 816 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3265 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 823 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3273 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 829 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3281 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 833 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3289 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 837 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3297 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 841 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3305 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 847 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3313 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 852 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3319 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 854 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3327 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 858 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3337 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 864 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3349 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 872 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3357 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 879 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3366 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 884 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3375 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 889 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3383 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 895 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3391 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 899 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3399 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 903 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3407 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 909 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3415 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 914 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3423 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 920 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3431 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 924 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3439 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* Label: LABEL  */
#line 985 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3445 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 990 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3454 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 996 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3462 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1001 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3471 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1007 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3480 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1014 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3489 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 1020 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3498 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1027 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3507 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1034 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3516 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1041 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3525 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1048 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3537 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1060 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3546 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1067 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3555 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1076 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3566 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1086 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3575 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1092 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3584 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1099 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3592 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1105 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3601 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1114 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3613 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1124 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3622 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1131 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3631 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1138 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3640 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1146 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3650 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1155 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3660 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1162 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3670 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1169 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3678 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* BreakpointInstruction: BREAKPOINT_OP  */
#line 1175 "CISA.y"
    {
      pBuilder->CISA_create_breakpoint_instruction(CISAlineno);
    }
#line 3686 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1181 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3695 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1187 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3704 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1193 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3713 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1211 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3722 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1218 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3733 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1228 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3743 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1236 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3753 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1242 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3762 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1250 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3772 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1259 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3782 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1268 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3792 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1277 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3802 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: BARRIER_OP  */
#line 1284 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3810 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1287 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3818 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1290 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3826 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1293 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3834 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1296 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3842 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1302 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3851 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1309 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3861 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* Atomic16Opt: %empty  */
#line 1316 "CISA.y"
             {(yyval.flag) = false;}
#line 3867 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* Atomic16Opt: DOT DEC_LIT  */
#line 1317 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3876 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1324 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3886 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1337 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3896 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1345 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3906 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* Sample3DInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1357 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3919 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* CPSEnableOpt: %empty  */
#line 1369 "CISA.y"
                     {(yyval.cps) = false;}
#line 3925 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* CPSEnableOpt: CPS  */
#line 1369 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3931 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* NonUniformSamplerEnableOpt: %empty  */
#line 1371 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3937 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1371 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3943 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* Load3DInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1379 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3956 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* Gather43DInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1395 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3969 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* PixelNullMaskEnableOpt: %empty  */
#line 1405 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3975 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1405 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3981 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1409 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3991 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1417 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 4001 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteOperands: %empty  */
#line 1425 "CISA.y"
    {
    }
#line 4008 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1428 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 4016 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1432 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 4024 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* RTWInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1441 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 4037 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* RTWriteModeOpt: %empty  */
#line 1451 "CISA.y"
                       {(yyval.string) = 0;}
#line 4043 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1456 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4053 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1464 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4065 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1476 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4083 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1492 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4091 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1498 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4106 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1511 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4115 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1519 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4124 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1526 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4133 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1534 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4142 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1540 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4151 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1546 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4160 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1552 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4169 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1558 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4178 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 210: /* AtomicBitwidthOpt: %empty  */
#line 1564 "CISA.y"
             {(yyval.intval) = 32;}
#line 4184 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 211: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1565 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4193 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1620 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4218 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1652 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[0].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4243 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1682 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_block2d_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[0].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4266 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1710 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4291 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1736 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_addr_operand).surfaceIndex, // surface index
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4316 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1764 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_block2d_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[0],
            (yyvsp[-1].lsc_block2d_addr_operand).immOffsets[1],
            CISAlineno);
    }
#line 4339 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1793 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,         // address info
            (yyvsp[-3].lsc_data_operand).shape,        // data type
            (yyvsp[-2].lsc_addr_operand).surface,      // surface array base
            (yyvsp[-2].lsc_addr_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,          // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],      // src0 addr
            (yyvsp[-1].RawVar),              // src1 data
            (yyvsp[0].RawVar),              // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4364 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets  */
#line 1827 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_typed_operand).addr.type,      // address type
            (yyvsp[0].lsc_typed_operand).addr.size,      // address size
            (yyvsp[-1].lsc_data_operand).shape,          // data
            (yyvsp[0].lsc_typed_operand).surface,        // surface
            (yyvsp[0].lsc_typed_operand).surfaceIndex,   // surface index
            (yyvsp[-1].lsc_data_operand).reg,            // dst
            (yyvsp[0].lsc_typed_operand).regs[0],        // src0_u
            (yyvsp[0].lsc_typed_operand).uvrOffsets[0],  // u offset
            (yyvsp[0].lsc_typed_operand).regs[1],        // src0_v
            (yyvsp[0].lsc_typed_operand).uvrOffsets[1],  // v offset
            (yyvsp[0].lsc_typed_operand).regs[2],        // src0_r
            (yyvsp[0].lsc_typed_operand).uvrOffsets[2],  // r offset
            (yyvsp[0].lsc_typed_operand).regs[3],        // src0_lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
    }
#line 4399 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperandWithOffsets LscDataOperand  */
#line 1871 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_typed_operand).addr.type,     // address model
            (yyvsp[-1].lsc_typed_operand).addr.size,     // address size
            (yyvsp[0].lsc_data_operand).shape,         // data size
            (yyvsp[-1].lsc_typed_operand).surface,       // surface
            (yyvsp[-1].lsc_typed_operand).surfaceIndex,  // surface index
            nullptr,          // dst
            (yyvsp[-1].lsc_typed_operand).regs[0],       // src0_u
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-1].lsc_typed_operand).regs[1],       // src0_v
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-1].lsc_typed_operand).regs[2],       // src0-r
            (yyvsp[-1].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-1].lsc_typed_operand).regs[3],       // src0_lod
            (yyvsp[0].lsc_data_operand).reg,           // stored data
            nullptr,          // src2
            CISAlineno);
    }
#line 4434 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperandWithOffsets LscPayloadReg LscPayloadReg  */
#line 1916 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_typed_operand).addr.type, // address model
            (yyvsp[-2].lsc_typed_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_typed_operand).surface,  // surface
            (yyvsp[-2].lsc_typed_operand).surfaceIndex, // surface index
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_typed_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[0], // u offset
            (yyvsp[-2].lsc_typed_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[1], // v offset
            (yyvsp[-2].lsc_typed_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_typed_operand).uvrOffsets[2], // r offset
            (yyvsp[-2].lsc_typed_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4466 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscAddrModelStateful LBRACK LscPayloadNonNullReg RBRACK  */
#line 1952 "CISA.y"
   {
        LSC_CACHE_OPTS caching {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape {LSC_DATA_SIZE_32b,LSC_DATA_ORDER_TRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_16;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-7].pred_reg),              // predicate
            (yyvsp[-6].lsc_subOpcode),              // subop
            (yyvsp[-5].lsc_sfid),              // sfid
            caching,         // no caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[-3].lsc_addr_model).type,           // address type
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[-3].lsc_addr_model).surface,        // surface
            (yyvsp[-3].lsc_addr_model).surfaceIndex,   // SS_IDX
            (yyvsp[-4].RawVar),                // dst data
            (yyvsp[-1].RawVar),                // src0 coords (u, v, r, lod) SIMD1 are packed in
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            0,                 // no uvr-offsets
            nullptr,           // no other coords
            nullptr,           // no src1 data
            nullptr,           // no src2 data
            CISAlineno);
   }
#line 4499 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1989 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4507 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscCacheOpts: %empty  */
#line 1996 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4513 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1997 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4519 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1998 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4525 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 2005 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface, (yyvsp[-6].lsc_addr_model).surfaceIndex, {(yyvsp[-3].RawVar)}, {(yyvsp[-6].lsc_addr_model).type, (int)(yyvsp[-4].intval), (int)(yyvsp[-2].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4533 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm32 RBRACK LSC_ADDR_SIZE_TK  */
#line 2014 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface, (yyvsp[-8].lsc_addr_model).surfaceIndex, {(yyvsp[-5].RawVar), (yyvsp[-2].lsc_addr_surface_ident)}, {(yyvsp[-8].lsc_addr_model).type, (int)(yyvsp[-6].intval), (int)(yyvsp[-4].intval), (yyvsp[0].lsc_addr_size)}};
    }
#line 4541 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 2017 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4550 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpReg LscAddrImmOffsetOpt COMMA LscVectorOpReg LscAddrImmOffsetOpt RBRACK  */
#line 2041 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-13].lsc_addr_surface_ident),(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-2].lsc_addr_surface_ident)},{(int)(yyvsp[-4].intval), (int)(yyvsp[-1].intval)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4558 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpRegOrImm32 COMMA LscVectorOpImm32 COMMA LscVectorOpImm32 RBRACK  */
#line 2061 "CISA.y"
    {
        (yyval.lsc_block2d_addr_operand) = {nullptr,0,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{0, 0},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4566 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg  */
#line 2066 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[0].RawVar), 0};
    }
#line 4574 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg PLUS IntExpMul  */
#line 2069 "CISA.y"
                                          {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)(yyvsp[0].intval)};
    }
#line 4582 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscTypedAddrWithOffsetOperand: LscPayloadNonNullReg MINUS IntExpMul  */
#line 2073 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand) = {(yyvsp[-2].RawVar), (int)-(yyvsp[0].intval)};
    }
#line 4590 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand  */
#line 2077 "CISA.y"
                                    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[0].lsc_typed_addr_operand).offset, 0, 0}};
      }
#line 4598 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2082 "CISA.y"
      {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset, 0}};
      }
#line 4606 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand  */
#line 2088 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].lsc_typed_addr_operand).reg}, {(yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset, (yyvsp[0].lsc_typed_addr_operand).offset}};
    }
#line 4614 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscTypedAddrWithOffsetOperandList: LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscTypedAddrWithOffsetOperand COMMA LscPayloadNonNullReg  */
#line 2095 "CISA.y"
    {
        (yyval.lsc_typed_addr_operand_list) = {{(yyvsp[-6].lsc_typed_addr_operand).reg,(yyvsp[-4].lsc_typed_addr_operand).reg,(yyvsp[-2].lsc_typed_addr_operand).reg,(yyvsp[0].RawVar)}, {(yyvsp[-6].lsc_typed_addr_operand).offset, (yyvsp[-4].lsc_typed_addr_operand).offset, (yyvsp[-2].lsc_typed_addr_operand).offset}};
    }
#line 4622 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscTypedAddrOperandWithOffsets: LscAddrModelStateful LBRACK LscTypedAddrWithOffsetOperandList RBRACK LSC_ADDR_SIZE_TK  */
#line 2101 "CISA.y"
    {
        (yyval.lsc_typed_operand) = {(yyvsp[-4].lsc_addr_model).surface, (yyvsp[-4].lsc_addr_model).surfaceIndex,
               {(yyvsp[-2].lsc_typed_addr_operand_list).regs[0], (yyvsp[-2].lsc_typed_addr_operand_list).regs[1], (yyvsp[-2].lsc_typed_addr_operand_list).regs[2],(yyvsp[-2].lsc_typed_addr_operand_list).regs[3]},
               {(yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[0], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[1], (yyvsp[-2].lsc_typed_addr_operand_list).uvrOffsets[2]},
               {(yyvsp[-4].lsc_addr_model).type, 1, 0, (yyvsp[0].lsc_addr_size)}};
    }
#line 4633 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscAddrImmOffsetOpt: %empty  */
#line 2112 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4639 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2113 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4645 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscAddrImmOffsetOpt: MINUS IntExpMul  */
#line 2114 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4651 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscAddrImmScaleOpt: %empty  */
#line 2119 "CISA.y"
                     {(yyval.intval) = 1;}
#line 4657 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscAddrImmScaleOpt: IntExpPrim TIMES  */
#line 2120 "CISA.y"
                     {(yyval.intval) = (yyvsp[-1].intval);}
#line 4663 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscAddrModelOpt: %empty  */
#line 2123 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4669 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2124 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT, nullptr, 0};}
#line 4675 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2125 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG, nullptr, 0};}
#line 4681 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2130 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4689 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscAddrModelStateful: LSC_AM_BSS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2133 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BSS, (yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4697 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2136 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4705 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscAddrModelStateful: LSC_AM_SS LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2139 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_SS,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4713 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 RPAREN  */
#line 2142 "CISA.y"
                                                     {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-1].lsc_addr_surface_ident), 0};
    }
#line 4721 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscAddrModelStateful: LSC_AM_BTI LPAREN LscVectorOpRegOrImm32 COMMA IntExp RPAREN  */
#line 2145 "CISA.y"
                                                                  {
      (yyval.lsc_addr_model) = {LSC_ADDR_TYPE_BTI,(yyvsp[-3].lsc_addr_surface_ident), (int)(yyvsp[-1].intval)};
    }
#line 4729 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscVectorOpImm32: IntExp  */
#line 2154 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval), ISA_TYPE_UD, CISAlineno);
    }
#line 4737 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* LscVectorOpReg: Var  */
#line 2164 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4749 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2172 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4761 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2180 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4778 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2194 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4786 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2198 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4794 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2204 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4802 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscPayloadReg: Var  */
#line 2212 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4810 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* LscPayloadNonNullReg: VarNonNull  */
#line 2219 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4818 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* SwitchLabels: %empty  */
#line 2225 "CISA.y"
    {
    }
#line 4825 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* SwitchLabels: COMMA SwitchLabels  */
#line 2228 "CISA.y"
    {
    }
#line 4832 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* SwitchLabels: IDENT SwitchLabels  */
#line 2231 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4841 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2238 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4849 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2242 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4857 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2246 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4865 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2250 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4874 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2256 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4882 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2261 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, false,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4892 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* BranchInstruction: Predicate IFCALL UNIFORM ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2268 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, true,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4902 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2275 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4910 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* FILE: FILE_OP STRING_LIT  */
#line 2280 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4918 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* LOC: LOC_OP DEC_LIT  */
#line 2285 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4926 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2291 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4935 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2298 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4944 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2305 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4952 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2311 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4960 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2317 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4971 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2325 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4982 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2333 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4993 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2341 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 5004 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2351 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5012 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2356 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 5020 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* NullaryInstruction: YIELD_OP  */
#line 2361 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 5028 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2366 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 5036 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2371 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 5044 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2376 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 5052 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2381 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 5060 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* NullaryInstruction: FENCE_SW_OP  */
#line 2386 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 5068 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* OwordModifier: %empty  */
#line 2390 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 5074 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* Predicate: %empty  */
#line 2397 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 5082 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2402 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 5090 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* PredSign: %empty  */
#line 2406 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 5096 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* PredSign: BANG  */
#line 2406 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 5102 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* PredCtrlOpt: %empty  */
#line 2408 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 5108 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* SatModOpt: %empty  */
#line 2411 "CISA.y"
                  {(yyval.sat) = false;}
#line 5114 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* SatModOpt: SAT  */
#line 2411 "CISA.y"
                                      {(yyval.sat) = true;}
#line 5120 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* SrcModifier: SRCMOD_NEG  */
#line 2414 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 5126 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* SrcModifier: SRCMOD_ABS  */
#line 2415 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 5132 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* SrcModifier: SRCMOD_NEGABS  */
#line 2416 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 5138 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* SrcModifier: SRCMOD_NOT  */
#line 2417 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 5144 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* ConditionalModifier: %empty  */
#line 2419 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5150 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecDstOperand_A: DstAddrOperand  */
#line 2424 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5156 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* VecDstOperand_G: DstGeneralOperand  */
#line 2425 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5162 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2427 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5168 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2428 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5174 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2433 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5180 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2437 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5186 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2441 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5192 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2442 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5198 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2446 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5204 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2450 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5210 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2451 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5216 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2455 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5222 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2459 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5228 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2461 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5234 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2464 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5246 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2474 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5255 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2481 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5265 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2489 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5275 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2497 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5285 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2528 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5294 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2535 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5302 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2546 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5311 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2551 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5320 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* RawOperandArray: %empty  */
#line 2559 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5328 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2564 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5337 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2572 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5347 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2580 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5356 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* DstGeneralOperand: Var DstRegion  */
#line 2585 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5365 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2591 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5374 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* SrcAddrOfOperand: AddrOfVar  */
#line 2612 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5382 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2616 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5391 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* AddrOfVar: AMP Var  */
#line 2622 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5404 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2633 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5414 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2641 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5424 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2648 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5434 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2658 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5442 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2663 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5452 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* SrcImmOperand: FloatLit  */
#line 2671 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5460 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcImmOperand: MINUS FloatLit  */
#line 2674 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5468 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* SrcImmOperand: DoubleFloatLit  */
#line 2680 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5476 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2684 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5484 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* FloatLit: DEC_LIT FTYPE  */
#line 2691 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5495 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* FloatLit: HEX_LIT FTYPE  */
#line 2698 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5505 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2706 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5516 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2712 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5527 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2723 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5538 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2731 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5549 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2740 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5559 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2758 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5575 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2775 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5589 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 388: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2786 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5601 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2796 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5610 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2801 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5619 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2806 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5630 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* PredVar: Var  */
#line 2814 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5642 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2823 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5657 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2835 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5672 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* SIMDMode: %empty  */
#line 2849 "CISA.y"
           {(yyval.intval) = 0;}
#line 5678 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2852 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5688 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* ElemNum: DOT DEC_LIT  */
#line 2863 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5696 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2875 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5705 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2881 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5716 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* ExecSizeInt: DEC_LIT  */
#line 2889 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5727 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2903 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5733 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2906 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5739 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2909 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5745 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2912 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5751 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 414: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2915 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5757 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2916 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5763 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2919 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5769 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2920 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5775 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 419: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2921 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5781 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2922 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5787 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 423: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2945 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5793 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2946 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5799 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 425: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2947 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5805 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2950 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5811 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2951 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5817 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2954 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5823 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 431: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2955 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5833 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 432: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2960 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5843 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 434: /* IntExpUnr: MINUS IntExpUnr  */
#line 2967 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5849 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 435: /* IntExpUnr: TILDE IntExpUnr  */
#line 2968 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5855 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 436: /* IntExpUnr: BANG IntExpUnr  */
#line 2969 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5861 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2977 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5867 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 441: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2981 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5876 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 442: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2985 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5886 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;

  case 443: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2991 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5897 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"
    break;


#line 5901 "/home/abuild/rpmbuild/BUILD/build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3009 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
